(ns reqrep.Utils)

(def numberOfCpus
  (.availableProcessors (Runtime/getRuntime)))

(def not-nil? (complement nil?))

;; The following was borrowed from: https://github.com/fogus/ring-edn/blob/master/src/ring/middleware/edn.clj
(defprotocol EdnRead
  (-read-edn [this]))

(extend-type String
  EdnRead
  (-read-edn [s]
    (read-string s)))

(extend-type java.io.InputStream
  EdnRead
  (-read-edn [is]
    (read (java.io.PushbackReader.
           (java.io.InputStreamReader.
             is "UTF-8"))
          false
          nil)))

(defn readMsg [msg]
  (-read-edn msg))

(defn writeMsg [msg]
  (pr-str msg))
